var _excluded = ["multiple", "onCheck", "checkedKeysMap", "checkStrictly", "rootClassName"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { Icon, Tree, Tooltip } from 'rlj-design';
import classnames from 'classnames';
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-baseTree"); // const { TextOverFlow } = Typography;
// 二次封装Tree，使其兼容多选与单选，并且增加点击title进行选中的功能

var DeptTree = function DeptTree(_ref) {
  var _ref$multiple = _ref.multiple,
      multiple = _ref$multiple === void 0 ? false : _ref$multiple,
      onCheck = _ref.onCheck,
      checkedKeysMap = _ref.checkedKeysMap,
      checkStrictly = _ref.checkStrictly,
      rootClassName = _ref.rootClassName,
      restProps = _objectWithoutProperties(_ref, _excluded);

  // 统一处理点击时的操作，主要是为了区分单选和多选时的处理
  var comCheckedHandle = function comCheckedHandle(info) {
    var node = info.node,
        checkedNodes = info.checkedNodes;
    var key = node.key;
    var checkedKeys = restProps.checkedKeys; // 判断当前节点是否被勾选

    var hasChecked = checkedKeysMap ? checkedKeysMap === null || checkedKeysMap === void 0 ? void 0 : checkedKeysMap.get(key) : checkedKeys === null || checkedKeys === void 0 ? void 0 : checkedKeys.some(function (item) {
      return item === key;
    });
    var temp = new Map(checkedKeysMap || []); // 判断当前是否单选，及当前节点是否选择，单选情况下二次点击不取消当前选择

    if (!multiple) {
      if (hasChecked) return false;
      temp.clear();
      temp.set(key, node);
    } else {
      if (checkStrictly) {
        if (!hasChecked) {
          temp.set(key, node);
        } else {
          temp.delete(key);
        }
      } else {
        if (!hasChecked) {
          var parentNode = checkedNodes === null || checkedNodes === void 0 ? void 0 : checkedNodes.filter(function (item) {
            return item.key === node.parentOrgId;
          });

          if (parentNode !== null && parentNode !== void 0 && parentNode.length) {
            var _parentNode$;

            temp.set((_parentNode$ = parentNode[0]) === null || _parentNode$ === void 0 ? void 0 : _parentNode$.key, parentNode[0]);
          }

          temp.set(key, node);
        } else {
          temp.delete(key);
        }
      }
    }

    return temp;
  };

  var onTreeCheck = function onTreeCheck(checkedKeysValue, info) {
    onCheck && onCheck(checkedKeysValue, info, comCheckedHandle(info));
  };

  return /*#__PURE__*/React.createElement(Tree, _extends({
    checkable: true,
    onCheck: onTreeCheck,
    selectable: false,
    rootClassName: classnames(prefixCls, rootClassName),
    showIcon: true,
    showLine: true,
    checkStrictly: multiple && checkStrictly,
    blockNode: true,
    titleRender: function titleRender(_ref2) {
      var tip = _ref2.tip,
          key = _ref2.key,
          title = _ref2.title;
      return /*#__PURE__*/React.createElement(Tooltip, {
        title: tip
      }, /*#__PURE__*/React.createElement("span", {
        key: key,
        className: classnames(_defineProperty({}, "".concat(prefixCls, "-disabled"), tip))
      }, /*#__PURE__*/React.createElement("span", null, title)));
    },
    icon: /*#__PURE__*/React.createElement(Icon, {
      type: "organizationAreality"
    }),
    switcherIcon: /*#__PURE__*/React.createElement(Icon, {
      type: "dropDownArrowDown",
      style: {
        fontSize: 12,
        color: '#7f7f85'
      }
    }),
    multiple: multiple
  }, restProps));
};

export default DeptTree;