import React, { useMemo } from 'react';
import classnames from 'classnames';
import { getPrimary } from "../utils/tools";
import { caretDown } from "../utils/icon";
import { Dropdown } from 'rlj-design';
import "./index.less";
export var TYPE = {
  header: Symbol(),
  ctx: Symbol()
};
export var MODE = {
  diamond: Symbol(),
  checked: Symbol(),
  unChecked: Symbol()
};
export default function Checked(props) {
  var type = props.type,
      _props$rowSelection = props.rowSelection,
      rowSelection = _props$rowSelection === void 0 ? {} : _props$rowSelection,
      _props$dataSource = props.dataSource,
      dataSource = _props$dataSource === void 0 ? [] : _props$dataSource,
      _props$data = props.data,
      data = _props$data === void 0 ? {} : _props$data,
      _props$rowKey = props.rowKey,
      rowKey = _props$rowKey === void 0 ? 'id' : _props$rowKey;

  var _ref = rowSelection || {},
      _ref$selectedRowKeys = _ref.selectedRowKeys,
      selectedRowKeys = _ref$selectedRowKeys === void 0 ? [] : _ref$selectedRowKeys,
      _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange,
      rowSelectionIconSp = _ref.rowSelectionIconSp; // 防止 null


  var idsAll = useMemo(function () {
    return type === TYPE.ctx ? [] : dataSource.map(function (v) {
      return typeof rowKey === 'function' ? rowKey(v) : v[rowKey];
    });
  }, [dataSource]);

  var getId = function getId() {
    return typeof rowKey === 'function' ? rowKey(data) : data[rowKey];
  };

  var mode = Symbol();

  if (type === TYPE.header) {
    var tmp = selectedRowKeys.filter(function (v) {
      return idsAll.includes(v);
    });

    if (tmp.length === idsAll.length) {
      mode = MODE.checked;
    } else if (tmp.length) {
      mode = MODE.diamond;
    }
  } else if (type === TYPE.ctx) {
    if (selectedRowKeys.includes(getId())) {
      mode = MODE.checked;
    }
  }

  var handleCheck = function handleCheck() {
    if (type === TYPE.header) {
      if (mode === MODE.diamond) {
        onChange(idsAll);
      } else if (mode === MODE.checked) {
        onChange([]);
      } else {
        onChange(idsAll);
      }
    } else if (type === TYPE.ctx) {
      if (mode === MODE.checked) {
        onChange(selectedRowKeys.filter(function (v) {
          return v !== getId();
        }));
      } else {
        var _tmp = [].concat(selectedRowKeys);

        _tmp.push(getId());

        onChange(_tmp);
      }
    }
  };

  var menuClick = function menuClick(param) {
    if (type === TYPE.header) {
      var key = param.key;

      if (key === '1') {
        onChange(idsAll, true);
      }

      if (key === '2') {
        onChange(idsAll, false);
      }

      if (key === '3') {
        onChange([]);
      }
    }
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(CheckBox, {
    value: mode,
    onChange: handleCheck
  }), rowSelectionIconSp && type === TYPE.header && /*#__PURE__*/React.createElement(Dropdown, {
    trigger: ['click'],
    menu: {
      items: [{
        key: 1,
        label: '选择全部'
      }, {
        key: 2,
        label: '选择当前页'
      }, {
        key: 3,
        label: '取消全选'
      }],
      onClick: menuClick
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "iconRowSelectionSp"
  }, caretDown)));
}
export var CheckBox = function CheckBox(props) {
  var value = props.value,
      _props$onChange = props.onChange,
      onChange = _props$onChange === void 0 ? function () {} : _props$onChange;
  return /*#__PURE__*/React.createElement("div", {
    onClick: onChange,
    className: getPrimary(classnames('tExcel-checkbox', {
      diamond: value === MODE.diamond,
      checked: value === MODE.checked
    }))
  });
};