function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import Checked, { TYPE as CheckType } from "../../Checked";
import Ellipsis from "../../components/Ellipsis";
import classnames from 'classnames';
import { caretRight, caretDown, loadingIcon, delIcon } from "../../utils/icon";
import { getPrimary, getKey, getRowKeys, getErrorDisabled } from "../../utils/tools";
import { AssistIcon } from "./assistIcon";
import "./index.less";
import Undertake from "../../undertake";
import { areEqual } from "../../validate";
var preSpClickFlag = false; // rowIndex columnIndex 等这些index，都是根据块noFixed fixLeft fixRight来作为索引开始的值

// 所有单元格cell都使用这个组件，但是这个Item只是起到分流的作用
// 原因：3个表头合并，带来的结果是数据单元格就是3个一组
var Item = function Item(props) {
  var currentColumn = props.currentColumn;
  var children = currentColumn.children;
  return children ? /*#__PURE__*/React.createElement("div", {
    className: "salaryExcelDataItemBox"
  }, children.map(function (v, index) {
    return /*#__PURE__*/React.createElement(Cell, _extends({
      key: getKey(v)
    }, props, {
      currentColumn: v,
      subColumnIndex: index,
      isMergeCol: true
    }));
  })) : /*#__PURE__*/React.createElement(Cell, _extends({}, props, {
    subColumnIndex: 0
  }));
}; // 正儿八经的单元格


var CellCtx = /*#__PURE__*/React.memo(function (props) {
  var _expandConfig$expandK;

  // console.log('Item-re-render');
  var isMergeRow = props.isMergeRow,
      rowIndex = props.rowIndex,
      subRowIndex = props.subRowIndex,
      currentData = props.currentData,
      currentColumn = props.currentColumn,
      excelCtx = props.excelCtx,
      dataCtx = props.dataCtx,
      mergeData = props.mergeData;
  var _ref = excelCtx,
      rowSelection = _ref.rowSelection,
      selectOneRow = _ref.selectOneRow,
      editableConfig = _ref.editableConfig,
      hoverRowHighlight = _ref.hoverRowHighlight,
      defaultShowCtx = _ref.defaultShowCtx,
      crosswalk = _ref.crosswalk,
      _ref$rowKey = _ref.rowKey,
      rowKey = _ref$rowKey === void 0 ? 'id' : _ref$rowKey,
      dataSource = _ref.dataSource,
      changeTable = _ref.changeTable,
      colData = _ref.colData,
      expandConfig = _ref.expandConfig,
      loadingExpandId = _ref.loadingExpandId;
  var _ref2 = dataCtx,
      mergeHoverIndex = _ref2.mergeHoverIndex,
      changeRedux = _ref2.changeRedux;
  var isOdd = isMergeRow ? false : rowIndex % 2 !== 0; //是否奇数行

  var _ref3 = rowSelection || {},
      _ref3$selectedRowKeys = _ref3.selectedRowKeys,
      selectedRowKeys = _ref3$selectedRowKeys === void 0 ? [] : _ref3$selectedRowKeys;

  var _ref4 = editableConfig || {},
      editable = _ref4.editable,
      hoverRowShowDel = _ref4.hoverRowShowDel,
      _ref4$infos = _ref4.infos,
      infos = _ref4$infos === void 0 ? [] : _ref4$infos,
      _ref4$disabled = _ref4.disabled,
      disabledProps = _ref4$disabled === void 0 ? [] : _ref4$disabled;

  var width = currentColumn.width,
      valueType = currentColumn.valueType,
      info = currentColumn.info,
      lastCol = currentColumn.lastCol,
      disabled = currentColumn.disabled,
      render = currentColumn.render;
  var dataIndex = getKey(currentColumn);
  var dataRowId = getRowKeys(rowKey, currentData); // 编辑态+不等于【显示斑马线】  或者  显示态+【显示斑马线】

  if (editable && crosswalk !== true || !editable && crosswalk === false) {
    isOdd = false;
  }

  var infoStatus = getErrorDisabled(infos, dataIndex, dataRowId);
  var isDisabled = disabled || !!getErrorDisabled(disabledProps, dataIndex, dataRowId);

  var preSpClick = function preSpClick() {
    if (preSpClickFlag) return;
    preSpClickFlag = true;
    changeTable({
      dataRowId: dataRowId,
      data: currentData
    }, 'delOneRow');
    setTimeout(function () {
      preSpClickFlag = false;
    }, 100);
  };

  var getLabel = function getLabel(ctxWidth) {
    var dataItem = currentData[dataIndex]; // 获取 dataIndex 指定的数据

    var renderItem = render || function (v) {
      return v;
    };

    var result = renderItem(dataItem, currentData, rowIndex, ctxWidth);
    var defaultShowText = defaultShowCtx === undefined ? '-' : defaultShowCtx;
    return [result === undefined ? defaultShowText : result, dataItem];
  }; // 现有场景：如果表头有合并了2个单元格，那么数据区域就需要连着渲染2个单元格，index标明了是第几个单元格


  var itemMergeMultiple = 1;

  if (subRowIndex !== undefined) {
    var mergeColObj = ((mergeData === null || mergeData === void 0 ? void 0 : mergeData.mergeField) || []).find(function (v) {
      return v.key === dataIndex;
    }); // 如果mergeColObj存在 => 需要合并 => 取mergeColObj的area字段 => 范围控制

    if (mergeColObj) {
      var placeTarget = mergeColObj.area.find(function (v) {
        if (v && v.length === 2) {
          return subRowIndex >= v[0] && subRowIndex <= v[1];
        } else {
          return false;
        }
      });

      if (placeTarget) {
        var _placeTarget = _slicedToArray(placeTarget, 2),
            mergeColAreaMin = _placeTarget[0],
            mergeColAreaMax = _placeTarget[1];

        if (subRowIndex === mergeColAreaMin) {
          itemMergeMultiple = mergeColAreaMax - mergeColAreaMin + 1;
        } else if (subRowIndex > mergeColAreaMin && subRowIndex <= mergeColAreaMax) {
          return null;
        }
      }
    }
  } // 第一个列内的第一个单元格，并且这个单元格标明了要显示图标 => 缩进特殊处理


  var isNeedPd = currentData.expandShowIcon !== false && currentColumn.expandCol; // 需要根据第一行数据是否显示图标来计算出具体的缩进距离

  var extraW = 0;

  if (isNeedPd) {
    extraW = (currentData.hierarchy - (dataSource[0].expandShowIcon !== false ? 0 : 1)) * 20;
  } // 先减掉左右固定的10 + 10的padding


  var ctxWidth = width - 20;

  if (info) {
    ctxWidth -= 20;
  }

  if (isNeedPd) {
    ctxWidth -= extraW;
  }

  if (ctxWidth <= 22) {
    ctxWidth = 22;
    extraW = width - ctxWidth;
  }

  var _getLabel = getLabel(ctxWidth),
      _getLabel2 = _slicedToArray(_getLabel, 2),
      label = _getLabel2[0],
      labelText = _getLabel2[1];

  return /*#__PURE__*/React.createElement(AssistIcon, {
    key: dataIndex,
    rowIndex: rowIndex,
    currentData: currentData,
    currentColumn: _objectSpread(_objectSpread({}, currentColumn), {}, {
      disabled: isDisabled
    }),
    width: width,
    fatherTmp: /*#__PURE__*/React.createElement("div", {
      className: getPrimary(classnames('salaryExcelDataItem', {
        salaryExcelDataItemHover: mergeHoverIndex === rowIndex,
        salaryExcelDataItemGrey: isOdd,
        salaryExcelDataItemDisabled: isDisabled,
        intValueStyle: (valueType === 'int' || valueType === 'number') && (true || !editable),
        lastColHiddenBorder: lastCol,
        salaryExcelDataItemChecked: selectedRowKeys.includes(getRowKeys(rowKey, currentData)),
        salaryExcelDataItemHighlight: dataIndex === 'rowPrefixSp' && selectOneRow && selectOneRow.rowIndex === rowIndex
      })),
      onMouseEnter: function onMouseEnter() {
        if (window.stopHover) return;

        if (hoverRowHighlight) {
          changeRedux({
            mergeHoverIndex: rowIndex
          });
        }
      },
      style: {
        width: width,
        height: colData.defaultItemHeight * itemMergeMultiple
      }
    }),
    childrenTmp: /*#__PURE__*/React.createElement(React.Fragment, null, dataIndex === 'rowSelection' ? /*#__PURE__*/React.createElement(Checked, {
      type: CheckType.ctx,
      data: currentData,
      rowKey: rowKey,
      rowSelection: rowSelection
    }) : dataIndex === 'rowPrefixSp' ? /*#__PURE__*/React.createElement("div", {
      className: "salaryExcelDataItemPrefixSp",
      onClick: preSpClick
    }, hoverRowShowDel && mergeHoverIndex === rowIndex ? delIcon : rowIndex + 1) : /*#__PURE__*/React.createElement(React.Fragment, null, isNeedPd && /*#__PURE__*/React.createElement("div", {
      className: "salaryExcelArrow",
      style: {
        width: extraW
      }
    }, /*#__PURE__*/React.createElement("span", {
      onClick: function onClick() {
        return changeTable(currentData, 'toggleRowExpand');
      }
    }, currentData.expandShowIcon !== false && currentData.expand && (loadingExpandId === currentData[(_expandConfig$expandK = expandConfig === null || expandConfig === void 0 ? void 0 : expandConfig.expandKey) !== null && _expandConfig$expandK !== void 0 ? _expandConfig$expandK : 'expandId'] ? loadingIcon : currentData.expandStatus ? caretDown : caretRight))), /*#__PURE__*/React.createElement(Ellipsis, {
      text: label,
      width: ctxWidth,
      hover: infoStatus ? !infoStatus.msg : true,
      isMaxWidth: false
    }), info && /*#__PURE__*/React.createElement("div", {
      className: "salaryExcelDataInfo"
    }, info(labelText, currentData, rowIndex, ctxWidth))))
  });
}, areEqual);
var Cell = Undertake(CellCtx);
export default Item;