function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useContext } from 'react';
import classnames from 'classnames';
import Ellipsis from "../../components/Ellipsis";
import "./item.less";
import { ExcelContext } from "../../index";
export default (function (props) {
  var _ref = useContext(ExcelContext),
      editableConfig = _ref.editableConfig,
      selectOneRow = _ref.selectOneRow,
      colData = _ref.colData,
      summation = _ref.summation;

  var summationData = summation === null || summation === void 0 ? void 0 : summation.data;
  var style = props.style,
      mainColumns = props.mainColumns,
      nextColumns = props.nextColumns;
  var subColumns = mainColumns.children;
  var isNotShowSub = !subColumns || !subColumns.length; //短路，当children不存在的时候，不会执行后半部分，不用判断children是否是数组

  var _ref2 = editableConfig || {},
      editable = _ref2.editable; // 默认的高度样式


  var defaultStyle = {
    height: colData.defaultItemHeight
  };
  /**
   * 超长省略内容
   * @param text   文本内容
   * @param item   当天列详细信息
   * @param textWidth  文字宽度
   * @param className  类名
   */

  var renderContent = function renderContent(text, item, textWidth, className) {
    if (text === 'rowSelectionChecked') {
      return '';
    }

    if (item.firstCol && summation !== null && summation !== void 0 && summation.remark) {
      return /*#__PURE__*/React.createElement("div", null, summation === null || summation === void 0 ? void 0 : summation.remark);
    }

    if ([undefined, null, ''].includes(text)) {
      return '';
    }

    return /*#__PURE__*/React.createElement("div", {
      className: className
    }, /*#__PURE__*/React.createElement(Ellipsis, {
      text: text,
      width: textWidth,
      isMaxWidth: false
    }));
  };

  var renderItem = function renderItem() {
    // @ts-ignore;
    var item = function item(_item, nexItem) {
      var width = _item.width,
          valueType = _item.valueType,
          dataIndex = _item.dataIndex;
      var ctxWidth = width - 20;
      var className = '';

      if (['int', 'number'].includes(valueType) && (true || !editable)) {
        className += ' int-value-style';
      } // const curItemNoData = ['', undefined, null].includes(summationData?.[dataIndex]);
      // const nextItemHasData =
      //   !['', undefined, null].includes(summationData?.[nexItem ? nexItem.dataIndex : undefined]) ||
      //   (nexItem && nexItem.firstCol)
      //     ? !!summation?.remark
      //     : false;


      return /*#__PURE__*/React.createElement("div", {
        className: classnames('itemBox', {
          // curItemNoData,
          // nextItemHasData,
          lastColHiddenBorder: _item.lastCol,
          salaryExcelHeaderHighlight: selectOneRow && selectOneRow.dataIndex === dataIndex
        }),
        style: _objectSpread({
          width: width
        }, defaultStyle),
        key: dataIndex
      }, renderContent(summationData === null || summationData === void 0 ? void 0 : summationData[dataIndex], _item, ctxWidth, className));
    };

    var getNextColumns = function getNextColumns(index) {
      if (mainColumns.children[index + 1]) {
        return mainColumns.children[index + 1];
      } else if (nextColumns) {
        if (nextColumns.children && nextColumns.children.length) {
          return nextColumns.children[0];
        } else {
          return nextColumns;
        }
      } else {
        return undefined;
      }
    }; // 没有子表头


    if (isNotShowSub) {
      return item(mainColumns, nextColumns);
    } else {
      return /*#__PURE__*/React.createElement("div", {
        className: "childrenBox"
      }, subColumns.map(function (v, i) {
        return item(v, getNextColumns(i));
      }));
    }
  }; // =============================================== render ===============================================


  return /*#__PURE__*/React.createElement("div", {
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames('salaryExcelSummationItem')
  }, renderItem()));
});